{
  "format_version": "1.13.0",
  "minecraft:tree_feature": {
    "description": {
      "identifier": "nicothekid:tree_x_mossy_rooted_01"
    },
    "mangrove_roots": {
      "max_root_width": 8,
      "max_root_length": 15,
      "y_offset": {
        "range_min": 1,
        "range_max": 4
      },
      "root_block": {
        "name": "nicothekid:roots_mossy"
      },
      "muddy_root_block": {
        "name": "minecraft:moss_block"
      },
      "mud_block": {
        "name": "minecraft:moss_block"
      },
      "above_root": {
        "above_root_block": "minecraft:moss_carpet",
        "above_root_chance": {
          "numerator": 1,
          "denominator": 2
        }
      },
      "roots_may_grow_through": [
        "nicothekid:roots_mossy",
        "minecraft:grass",
        "minecraft:dirt",
        "minecraft:moss_block",
        "minecraft:mud",
        "minecraft:muddy_mangrove_roots",
        "minecraft:moss_carpet",
        "minecraft:vine",
        "minecraft:snow_layer"
      ]
    },
    "mangrove_trunk": {
      "trunk_width": 1,
      "trunk_height": {
        "base": 4,
        "height_rand_a": 1,
        "height_rand_b": 4
      },
      "trunk_block": "nicothekid:mossy_log",
      "branches": {
        "branch_chance": 100.0,
        "branch_length": {
          "range_min": 0,
          "range_max": 1
        },
        "branch_steps": {
          "range_min": 1,
          "range_max": 4
        }
      }
    },
    "mangrove_canopy": {
      "canopy_height": 2,
      "canopy_radius": 3,
      "leaf_placement_attempts": 70,
      "leaf_blocks": [
        [ "nicothekid:mossy_leaves", 1 ]
      ],
      "canopy_decoration": {
        "decoration_block": "minecraft:vine",
        "decoration_chance": {
          "numerator": 1,
          "denominator": 4
        },
        "num_steps": 4,
        "step_direction": "down"
      },
      "hanging_block": "nicothekid:mossy_leaves",
      "hanging_block_placement_chance": {
        "numerator": 1,
        "denominator": 4
      }
    },
    "base_block": [
      "minecraft:moss_block"
    ],
    "may_replace": [
      {
        "tags": "query.any_tag('custom_leaves')"
      },
      {
        "tags": "query.any_tag('custom_plant')"
      },
      {
        "tags": "query.any_tag('custom_carpet')"
      },
      "minecraft:air",
      "minecraft:leaves",
      "minecraft:leaves2",
      "minecraft:azalea_leaves",
      "minecraft:azalea_leaves_flowered",
      "minecraft:mangrove_leaves",
      "minecraft:mangrove_propagule",
      "minecraft:azalea",
      "minecraft:big_dripleaf",
      "minecraft:brown_mushroom",
      "minecraft:double_plant",
      "minecraft:flowering_azalea",
      "minecraft:flowing_water",
      "minecraft:glow_lichen",
      "minecraft:moss_carpet",
      "minecraft:pink_petals",
      "minecraft:red_mushroom",
      "minecraft:sculk_vein",
      "minecraft:small_dripleaf_block",
      "minecraft:snow_layer",
      "minecraft:tallgrass",
      "minecraft:vine",
      "minecraft:water",
      "minecraft:web"
    ]
  }
}
